import 'package:flutter/widgets.dart';
import 'package:leancode_localization/src/translators/translator.dart';

class LocalizationDelegate extends LocalizationsDelegate<Translator> {
  const LocalizationDelegate(this.translators) : assert(translators != null);
  final Iterable<Translator> translators;

  Iterable<Locale> get supportedLocales => translators.map((t) => t.locale);

  @override
  bool isSupported(Locale locale) {
    return translators.any((t) => t.locale == locale);
  }

  @override
  Future<Translator> load(Locale locale) async {
    final translator = translators.firstWhere((t) => t.locale == locale);
    await translator.load();
    return translator;
  }

  @override
  bool shouldReload(LocalizationsDelegate<Translator> old) => false;
}
