import 'package:flutter/widgets.dart';
import 'package:leancode_localization/src/storages/locale_storage.dart';
import 'package:shared_preferences/shared_preferences.dart';

class SharedPrefsLocaleStorage implements LocaleStorage {
  @override
  Future<Locale> getLocale() async {
    final prefs = await SharedPreferences.getInstance();
    final data = prefs?.getStringList('locale');
    return data != null && data.length == 2 ? Locale(data[0], data[1]) : null;
  }

  @override
  Future<void> setLocale(Locale locale) async {
    final prefs = await SharedPreferences.getInstance();

    prefs?.setStringList('locale', [
      locale.languageCode,
      locale.countryCode,
    ]);
  }
}
